#include<math.h>
#include "pew.h"

static int g_cpallet[8][3]={{0,0,0},{0,0,15},{0,15,0},
			    {0,15,15},{15,0,0},
			    {15,0,15},{15,15,0},{15,15,15}};	
#define CELLMAX 512

float grids[CELLMAX][CELLMAX];
float grids2[CELLMAX][CELLMAX];
		  
void initialize_animation()
{
	int gd,gm;

        initgraph(&gd, &gm, "");
}

void initialize_animation_()
{
	int gd,gm;

        initgraph(&gd, &gm, "");
}

void xxx_particle()
{
}

static float filter[5][5]={
    {0,1,1,1,0},
    {1,1,2,1,1},
    {1,2,3,2,1},
    {1,1,2,1,1},
    {0,1,1,1,0}};

void contor_particle(x,n,time, rmax,ncell)
    REAL x[][DIM];
    int n;
    REAL time;
    REAL rmax;
    int ncell;
{
    int xmax,ymax, xc, yc, iskip;
    int cx,cy;
    double sqrt();
    REAL scale = 1.0/rmax;
    REAL fmax = 0;
    char ts[100];
    int i,j,k;
    int ii,is;
    float dscale;
    dscale = (ncell*ncell)/((double)n);
    printf("Enter contor particles \n");
    for(i=0;i<ncell;i++) for(j=0;j<ncell;j++) {
	grids[i][j]=0;
	grids2[i][j] = 0;
    }
    printf(" clear grid endparticles \n");
    xmax = ncell/2;
    ymax = ncell/2;
    cleardevice_pixmap();
    setcolor_pixmap(12);
    printf(" clear window end \n");
    is = (getmaxx()+2)/ncell;
    printf(" is = %d \n", is);
    for(i=0;i<n;i++){
	cx = xmax+xmax*x[i][0]*scale; 
	cy = ymax+ymax*x[i][1]*scale;
	if (cx >= 0 && cx < ncell && cy >= 0 && cy < ncell ){
	    grids[cx][cy] += 1;
	}
	if(fmax < grids[cx][cy]) fmax = grids[cx][cy];
	
    }
    fmax =  0;
    for(k=0;k<8;k++){
	for(i=2;i<ncell-2;i++) for(j=2;j<ncell-2;j++){
	    int ii,jj;
	    for(ii=-2;ii<3;ii++)for(jj=-2;jj<3;jj++){
		grids2[i][j] += filter[ii+2][jj+2]*grids[i+ii][j+jj];
	    }
	    if(fmax < grids2[cx][cy]) fmax = grids2[cx][cy];
	}
	for(i=0;i<ncell;i++) for(j=0;j<ncell;j++){
	    grids[i][j] = grids2[i][j]/27.0;
	    grids2[i][j]= 0;
	}
    }
    for(i=0;i<ncell;i++) for(j=0;j<ncell;j++){
	
	int icolor;
	icolor = (int)(sqrt(grids[i][j]*dscale)*5)+16;
	if(icolor >= NCOLORS)icolor = NCOLORS - 1;
	setcolor_pixmap(icolor);
	fillrectangle_pixmap(i*is,j*is,(i+1)*is,(j+1)*is);
    }
    
    gcvt(time,7,ts);
    setcolor_pixmap(15);
    outtextxy_pixmap(50,20,ts);
    copy_from_pixmap();
    xflush();
}   

	
void plot_particle_old(x,n,c,use_c,time, rmax)
REAL x[][DIM];
int n;
int c[];
int use_c;
REAL time;
REAL rmax;
{
         int xmax,ymax, xc, yc;
         int cx,cy;
	 REAL scale = 1.0/rmax;
         char ts[100];
#ifdef SORT_PARTICLES	 
          int izindex[NMAX];
          REAL valuez[NMAX];
#endif	 
	  int i;
          int ii,irad=10;
	  irad = 5*pow(n/100.0,-1.0/3.0);
          xmax = getmaxx()/2;
          ymax = getmaxy()/2;

#ifdef SORT_PARTICLES
          for(i=0;i<n;i++)izindex[i] = i;
          for(i=0;i<n;i++)valuez[i]=x[i][2];
          
          sort_particles(0,n-1,valuez,izindex);
#endif
          cleardevice();   
          setcolor(13);
          for(i=0;i<n;i++){
#ifdef SORT_PARTICLES	      
            ii = izindex[n-1-i];
#else
	    ii = i;
#endif	    
            cx = xmax+xmax*x[ii][0]*scale; 
	    cy = ymax+ymax*x[ii][1]*scale;
	    if(use_c) setcolor(c[ii]);
	    fprintf(stderr,"Plotting large %d %d\n", ii,c[ii]);
	    if (c[ii] != 15){
		fillellipse(cx,cy,irad,irad);
	    }else{
		fprintf(stderr,"Plotting large %d\n", ii);
		fillellipse(cx,cy,8,8);
	    }

          }
          gcvt(time,7,ts);
          xflush();
}   

#define MAXPOINTS 8192
void plot_particle(x,n,c,use_c,time, rmax)
REAL x[][DIM];
int n;
int c[];
int use_c;
REAL time;
REAL rmax;
{
         int xmax,ymax, xc, yc, iskip;
         int cx,cy;
	 REAL scale = 1.0/rmax;
         char ts[100];
#ifdef SORT_PARTICLES	 
          int izindex[NMAX];
          REAL valuez[NMAX];
#endif	 
	  int i;
          int ii,irad=10;
	  irad = 3*pow(n/100.0,-1.0/3.0)+1;
          xmax = getmaxx()/2;
          ymax = getmaxy()/2;

#ifdef SORT_PARTICLES
          for(i=0;i<n;i++)izindex[i] = i;
          for(i=0;i<n;i++)valuez[i]=x[i][2];
          
          sort_particles(0,n-1,valuez,izindex);
#endif
          cleardevice_pixmap();
          setcolor_pixmap(12);
	 
#if 1
          iskip = 1;
#else
          iskip = n/512+1;
#endif
          for(i=0;i<n;i+=iskip){
#ifdef SORT_PARTICLES	      
            ii = izindex[n-1-i];
#else
	    ii = i;
#endif	    
            cx = xmax+xmax*x[ii][0]*scale; 
	    cy = ymax+ymax*x[ii][1]*scale;
	    if(use_c) {
		if ((ii == 0) ||(c[ii] != c[ii-1])){
		    setcolor_pixmap(c[ii]);
		}
	    }
	    if (c[ii] != 15){
		fillellipse_pixmap(cx,cy,irad,irad);
	    }else{
		fillellipse_pixmap(cx,cy,5,5);
	    }
          }
          gcvt(time,7,ts);
          setcolor_pixmap(15);
	 outtextxy_pixmap(xmax*2-50,ymax*2-20,ts);
	  copy_from_pixmap();

          xflush();
}   

int set_pallet(c_org,c_diff)
int c_org,c_diff;
{
        int retnum;
	
	if(c_org!=0){
	    retnum=((15-c_diff*1.3) * (c_org)/15);
/*	    printf("c_org %d c_diff %d ret %d\n",c_org,c_diff,retnum);*/
	    return retnum;
	}
	return 0;
}


void set_pallet_down(gcnum)
int gcnum;
{
	int i;

	for(i=1;i<=7;i++){
	    setrgbpalette(i,set_pallet(g_cpallet[gcnum][0],7-i),
			  set_pallet(g_cpallet[gcnum][1],7-i),
			  set_pallet(g_cpallet[gcnum][2],7-i));
/*	    printf("%d cnum %d %d %d\n",i,set_pallet(g_cpallet[gcnum][0],7-i),
		   set_pallet(g_cpallet[gcnum][1],7-i),set_pallet(g_cpallet[gcnum][2],7-i));*/
	}
}


void set_pallet_up(gcnum)
int gcnum;    
{
	int i;

	for(i=8;i<=14;i++){
	    setrgbpalette(i,set_pallet(g_cpallet[gcnum][0],14-i),
			  set_pallet(g_cpallet[gcnum][1],14-i),
			  set_pallet(g_cpallet[gcnum][2],14-i));
	}
}

int ret_cnum(flag,z)
int flag;
REAL z;
{
    if(flag==0){
	if(z>0.9)      return 1;
	else if(z>0.8) return 2;
	else if(z>0.7) return 3;
	else if(z>0.6) return 4;
	else if(z>0.5) return 5;
	else if(z>0.4) return 6;
	else           return 7;
    }
    else{
	if(z>0.9)      return 8;
	else if(z>0.8) return 9;
	else if(z>0.7) return 10;
	else if(z>0.6) return 11;
	else if(z>0.5) return 12;
	else if(z>0.4) return 13;
	else           return 14;
    }	
}


void plot_particle3D(x,n,c,time)
REAL x[NMAX][DIM];
int n;
int c[NMAX];
REAL time;
{
	 static int ini=0;
         static int xmax1,ymax,xmax2;
         static int xmax1h,ymaxh,xmax2h;
         int cx,cy;
	 static REAL theta,sintheta,costheta;
	 REAL fx,fy,fz;
         char ts[100];
          int izindex[NMAX];
          REAL valuez[NMAX];
	  int i;
          int ii;
	 static int irad=10;

	if(ini==0){
	  ini=1;
          cleardevice();
	  set_pallet_down(6);
	  set_pallet_up(4);
	  irad = 4*pow(n/100.0,-1.0/3.0);
          xmax2 = getmaxx();
          xmax1 = xmax2/2;
          ymax = getmaxy();
	  xmax1h = xmax1/2;
          ymaxh = ymax/2;
	  theta = 3.0;
	  sintheta = sin(theta*PI/180.0);
	  costheta = cos(theta*PI/180.0);
	}
	  cleardevice_pixmap();

          for(i=0;i<n;i++)izindex[i] = i;
          for(i=0;i<n;i++)valuez[i]=x[i][2];
          
          sort_particles(0,n-1,valuez,izindex);
	  
          for(i=0;i<n;i++){
            ii = izindex[n-1-i];
            cx = xmax1*x[ii][0]; 
            cy = ymax*x[ii][1];
	    setcolor_pixmap(ret_cnum(c[ii],x[ii][2]));
	    
/*            if(c[ii]==0)setcolor_pixmap(14);
            if(c[ii]==1)setcolor_pixmap(12);
          if(x[ii][2]<0.2)fillellipse(cx,cy,5,5);*/

	    fx = costheta*(x[ii][0]-0.5)-sintheta*(x[ii][2]-0.5)+0.5; 
	    fz = (costheta*(x[ii][2]-0.5)+sintheta*(x[ii][0]-0.5)+0.5)*0.167;
	    cx = (xmax1*fx-xmax1h)/(1.0+fz)+xmax1h;
	    cy = (ymax*x[ii][1]-ymaxh)/(1.0+fz)+ymaxh;
            fillellipse_pixmap(cx,cy,irad,irad);

	    fx = costheta*(x[ii][0]-0.5)+sintheta*(x[ii][2]-0.5)+0.5;
	    fz = (costheta*(x[ii][2]-0.5)-sintheta*(x[ii][0]-0.5)+0.5)*0.167;
	    cx = (xmax1*fx-xmax1h)/(1.0+fz)+xmax1h+xmax1;
	    cy = (ymax*x[ii][1]-ymaxh)/(1.0+fz)+ymaxh;
            fillellipse_pixmap(cx,cy,irad,irad);
          }
          gcvt(time,7,ts);
          setcolor_pixmap(15);
          circle_pixmap(xmax1h,ymaxh,xmax1h);
          circle_pixmap(xmax1h+xmax1,ymaxh,xmax1h);
          outtextxy_pixmap(xmax2-50,ymax-20,ts);

	  copy_from_pixmap();
	 
	  xflush();
}   


#ifdef TESTMAIN

#define NN 100

REAL x[NN][3];
REAL c[NN];

main()
{
    int i,k, n;
    n = NN;
    for(i=0;i<n;i++){
	for(k=0;k<3;k++){
	    x[i][k] = i*(1.0/n);
	}
	c[i]=12;
    }
    initialize_animation();
    plot2_particle(x,n,c,0,0.0,1.0);
    sleep(5);
    closegraph();
}
#endif

